# NomQuery OS(OS原理赛道-模块实验创新)

## 项目简介

NomQuery OS 是一个基于 xv6 的操作系统项目，旨在通过模块实验创新来深入理解操作系统的原理和实现。该项目在 xv6 的基础上进行了多项扩展和改进，特别是在系统调用方面。

## 新增系统调用

我们在 xv6 原有系统调用的基础上，新增了以下系统调用：

- `SYS_hello` (22): 实现了一个简单的系统调用，用于输出 "Hello, world!"。
- `SYS_ps` (23): 实现了类似于 Linux 中 `ps` 命令的功能，展示当前运行的进程。
- `SYS_rename` (24): 实现了文件重命名功能。
- `SYS_vfork` (25): 实现了 `vfork` 系统调用，使父进程和子进程共享地址空间。
- `SYS_sched_yield` (26): 实现了进程让出 CPU 的功能。
- `SYS_getppid` (27): 返回当前进程的父进程 ID。
- `SYS_rmdir` (28): 实现了删除空目录的功能。
- `SYS_shutdown` (29): 实现了系统关机功能。
- `SYS_top` (30): 实现了类似于 Linux 中 `top` 命令的功能，展示系统的实时状态。
- `SYS_setpriority` (31): 实现了设置进程优先级的功能。
- `SYS_trace` (32): 实现了系统调用跟踪功能。
- `SYS_Kill` (33): 实现了发送信号以终止进程的功能。
- `SYS_signal` (34): 实现了信号处理功能。
- `SYS_sigsetmask` (35): 设置信号屏蔽字。
- `SYS_raise` (36): 向自身发送信号。
- `SYS_siggetmask` (37): 获取当前的信号屏蔽字。
- `SYS_sigreturn` (38): 从信号处理程序返回。
- `SYS_sigblock` (39): 阻塞指定的信号。
- `SYS_sigunblock` (40): 解除对指定信号的阻塞。
- `SYS_getcwd` (41): 获取当前工作目录。

这些新增的系统调用极大地增强了 xv6 的功能，使其更接近于现代操作系统的特性。

（主分支修改量超1700行代码，网络分支超1600行代码，主分支实现了19个系统调用）

## 贡献者(排名不分先后)

- 参赛队员：柳加恩、刘正庆、李秉璋

- 指导老师：王俊美、刘真

## 许可证

本项目基于 MIT 许可证开源，详细信息请参见 LICENSE 文件。

## 编译和运行

### 环境要求

- RISC-V 工具链
- QEMU 模拟器

### 编译步骤

1. 克隆项目代码：
    ```sh
    git clone https://your-repo-url/xv6-riscv.git
    cd xv6-riscv
    ```

2. 编译内核和用户程序：
    ```sh
    make
    ```

3. 运行 xv6：
    ```sh
    make qemu
    ```

## 文档

有关项目的详细设计和实现，请参阅以下文档：

- [文件系统模块设计文档](docs/文件系统模块.md)
- [进程模块设计文档](docs/进程模块.md)
- [信号处理设计文档](docs/信号处理.md)
- [网络模块设计文档](docs/网络模块.md)

## 联系方式

如果您有任何问题或建议，请通过以下方式联系我们：

- 邮箱: li.bz@outlook.com
- GitHub Issues: [项目问题追踪](https://github.com/your-repo-url/issues)

## 致谢

特别感谢所有为本项目提供支持和帮助的个人和组织。

## 未来计划

我们计划在未来的版本中继续改进和扩展 NomQuery OS，包括但不限于：

- 增加更多的系统调用
- 改进网络模块的功能
- 优化内存管理和调度算法
- 增加更多的用户态工具和应用程序
- 支持GUI界面

欢迎大家提出建议并参与到项目的开发中来！

## 参考资料

- xv6-riskv 项目主页: [https://github.com/mit-pdos/xv6-riscv]