#include "types.h"
#include "riscv.h"
#include "defs.h"
#include "param.h"
#include "memlayout.h"
#include "spinlock.h"
#include "proc.h"

uint64
sys_sigsetmask(void)
{
	int mask;
	argint(0, &mask);
  	return sigsetmask(mask);
}

uint64
sys_siggetmask(void)
{
	return siggetmask();
}


uint64
sys_raise(void)
{
	int pid;
	argint(0, &pid);
  	return raise(pid);
}


uint64
sys_Kill(void)
{
	int pid, signal;
	argint(0, &pid);
    argint(1, &signal);
	return Kill(pid, signal);
}

sighandler_t
sys_signal(void)
{
	int signum;
	int ptr1, sigretfn1;
	sighandler_t ptr;
	addr_sigret sigretfn;
	
	argint(0, &sigretfn1);
	argint(1, &signum);
	argint(2, &ptr1);
		
	ptr = (sighandler_t)(long)ptr1;
	sigretfn = (addr_sigret)(long)sigretfn1;
	return signal(sigretfn, signum, ptr);
	
}

uint64
sys_sigreturn(void)
{
	int signum;
	fetchaddr((myproc()->trapframe->sp), (uint64*)&signum);
	kernel_sigreturn(signum);
	return -1;
}

uint64
sys_sigblock(void)
{
	int signum;
	argint(0, &signum);
    return sigblock(signum);
}

uint64
sys_sigunblock(void)
{
	int signum;
	argint(0, &signum);
    return sigunblock(signum);
}