#include "kernel/types.h"
#include "kernel/stat.h"
#include "user/user.h"

int
main(int argc, char *argv[])
{
    int id = fork();
    if (id < 0)
    {
        fprintf(2, "%d failed in fork!\n", getpid());
        exit(0);
    }
    else if (id == 0)
    { // child
        fprintf(1, "Child %d created\n", getpid());
        double b = 1;
        for (int a = 0; a < 1000000000000; a += 1)
        {
            b += 0.001;
            b = b * 101010101.1 - 0.005 / 10.0;
        }
    }
    else
    { //parent
        //wait(&id);
        fprintf(1, "Parent %d killed\n", getpid());
    }
    exit(0);
}
