#include "kernel/types.h"
#include "kernel/stat.h"
#include "user/user.h"
#include "kernel/signal.h"

volatile int running = 1;

void sighandler(int signum) {
  if(signum == SIGINT) {
    running = 0;
  }
}

int main(int argc, char *argv[]) 
{
  int interval = 1;
  if(argc > 1) {
    interval = atoi(argv[1]);
  }
  
  // 注册SIGINT信号处理
  signal(SIGINT, sighandler);
  
  while(running) {
    top();
    sleep(interval*10);
  }
  
  exit(0);
}